#include <iostream>
#include <fstream>
#include <vector>
#include <time.h>
#include <stdlib.h>

using namespace std;

bool nyit(string jo, string proba);

int main()
	{
	vector<string> kodok;

	/*1. feladat: beolvasas*/

	ifstream fin;
	fin.open("ajto.txt");
	string kod;
	while(getline(fin, kod) != NULL)
		kodok.push_back(kod);
	fin.close();

	cout << "2. feladat\n";

	cout << "Adja meg, mi nyitja a zarat! ";
	cin >> kod;

	cout << "\n3. feladat\n";

	for (size_t i = 0; i < kodok.size(); i++)
		if (kodok[i] == kod)
			cout << i + 1 << " ";
	cout << endl;

	cout << "\n4. feladat\n";

	int jegyek[10];
	int ism = -1;
	for (size_t i = 0; i < kodok.size() && ism == -1; i++) {
			for (size_t j = 0; j < 10; j++) jegyek[j] = 0;
			for (size_t j = 0; j < kodok[i].size() && ism == -1; j++)
				if (jegyek[kodok[i][j] - '0'] == 1)
					ism = i;
				else
					jegyek[kodok[i][j] - '0']++;
			}
	if (ism == -1)
		cout << "nem volt ismetlodo szamjegy" << endl;
	else
		cout << "Az elso ismetlodest tartalmazo probalkozas sorszama: " << ism + 1 << endl;

	cout << "\n5. feladat\n";

	int hossz = kod.size();
	srand(time(0));
	string number = "0123456789";
	for (int i = 0; i < hossz; i++) {
			int ezt = i + (rand() % (10 - i));
			swap(number[i], number[ezt]);
			}
	for (int i = hossz; i < 10; i ++)
		number[i] = '\0';
	cout << "Egy " << hossz << " hosszu kodszam: " << number << endl;

	/*7. feladat: siker ellenrzs, kirs*/

	ofstream fout;
	fout.open("siker.txt");
	for (size_t i = 0; i < kodok.size(); i++) {
			fout << kodok[i] << " ";
			if (kod.size() != kodok[i].size())
				fout << "hibas hossz" << endl;
			else if (nyit(kod, kodok[i]))
				fout << "sikeres" << endl;
			else
				fout << "hibas kodszam" << endl;
			}
	fout.close();

	cout << "\nkesz." << endl;
	return 0;
	}


/*6. feladat: nyit() megirasa*/
bool nyit(string jo, string proba)
	{
	bool egyezik = (jo.size() == proba.size());
	if (egyezik) {
			int elteres = (int)jo[0] - (int)proba[0];
			for (size_t i = 1; i < jo.size(); i++)
				if ( elteres - ((int)jo[i] - (int)proba[i]) % 10 != 0)
					egyezik = false;
			}
	return egyezik;
	}
